"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }

var _chunk3SZ62L34cjs = require('./chunk-3SZ62L34.cjs');

// src/transform.ts
var _parser = require('@babel/parser');
var _traverse2 = require('@babel/traverse'); var _traverse3 = _interopRequireDefault(_traverse2);
var _compiler = require('@vue-jsx-vapor/compiler');
var _sourcemapjs = require('source-map-js');
var traverse = _traverse3.default.default || _traverse3.default;
var transformJSX = (path, state) => {
  if (_chunk3SZ62L34cjs.isJSXElement.call(void 0, path.parent)) return;
  const root = state.roots.shift();
  if (!root || !root.inVaporComponent) return;
  const isTS = _optionalChain([state, 'access', _ => _.filename, 'optionalAccess', _2 => _2.endsWith, 'call', _3 => _3("tsx")]);
  let { code, helpers, preamble, map } = _compiler.compile.call(void 0, root.node, {
    isTS,
    filename: state.filename,
    sourceMap: true,
    source: " ".repeat(root.node.start || 0) + root.source,
    ...state.opts.compile
  });
  helpers.forEach((helper) => state.importSet.add(helper));
  preamble = preamble.replaceAll(
    /(?<=const )t(?=(\d))/g,
    `_t${state.preambleIndex}`
  );
  code = code.replaceAll(/(?<== )t(?=\d)/g, `_t${state.preambleIndex}`);
  state.preambleIndex++;
  for (const [, key, value] of preamble.matchAll(
    /const (_t\d+) = (_template\(.*\))/g
  )) {
    const result = state.preambleMap.get(value);
    if (result) {
      code = code.replaceAll(key, result);
    } else {
      state.preambleMap.set(value, key);
    }
  }
  for (const [, events] of preamble.matchAll(/_delegateEvents\((.*)\)/g)) {
    events.split(", ").forEach((event) => state.delegateEventSet.add(event));
  }
  const ast = _parser.parse.call(void 0, `(() => {${code}})()`, {
    sourceFilename: state.filename,
    plugins: isTS ? ["jsx", "typescript"] : ["jsx"]
  });
  if (map) {
    const consumer = new (0, _sourcemapjs.SourceMapConsumer)(map);
    traverse(ast, {
      Identifier({ node: id }) {
        if (!id.loc) return;
        const originalLoc = consumer.originalPositionFor(id.loc.start);
        if (originalLoc.column) {
          id.loc.start.line = originalLoc.line;
          id.loc.start.column = originalLoc.column;
          id.loc.end.line = originalLoc.line;
          id.loc.end.column = originalLoc.column + id.name.length;
        }
      }
    });
  }
  path.replaceWith(ast.program.body[0]);
};



exports.transformJSX = transformJSX;
